#include "Wallpapers.h"
#include <algorithm>
#include <filesystem>
#include <iostream>

Wallpapers::Wallpapers(const std::string& directoryPath) : directoryPath(directoryPath) {

	for (const auto& entry : std::filesystem::directory_iterator(directoryPath)) {
		wallpapersPath.push_back(entry.path());
	}
	for (const std::string& wallpaperPath : wallpapersPath) {
		std::cout << wallpaperPath << std::endl;
	}
	e1 = std::default_random_engine(r());
	uniformDist = std::uniform_int_distribution<int>(0, wallpapersPath.size());
	wallpapersPathQueue = wallpapersPath;
}

void Wallpapers::shuffle() {
	wallpapersPathQueue = wallpapersPath;
	std::ranges::shuffle(wallpapersPathQueue, e1);
}

const std::string& Wallpapers::next() {
	const std::string& wallpaperPath = wallpapersPathQueue[currentWallpaperIndex];
	currentWallpaperIndex = (currentWallpaperIndex + 1) % wallpapersPathQueue.size();
	return wallpaperPath;
}
